		RADIX dec
;
		list	p=16F630           ; list directive to define processor
        #include	<p16F630.inc>
        errorlevel -302			; suppress "register not in bank0, check page bits" message.	
;

#define guardtime 3
clockrate equ 4000000         ;define clock rate here
guardconst	equ	(1+(guardtime*clockrate)/(4000*256*8))



vars	UDATA_SHR	0x20
delay	RES	2

		EXTERN 	trw_sendpacket,trw_getpacket,trw_setrx,trw_setch,trw_init,trw_address
		EXTERN	message


reset	CODE	0
		goto start

ioffset	CODE 0x4

initint	CODE

start   clrf   	PORTA			; 
        clrf   	PORTC			; 
        movlw   B'00000111'		; Comparator off
        movwf   CMCON
		bsf STATUS,RP0 			; Bank 1
		call 3FFh 				; Get the cal value
		movwf OSCCAL 			; Calibrate
        movlw   B'00000000'		; Enable pull-up only in (none)
        movwf   WPUA
        movlw   B'00001111'		; Enable pull-ups, WDT 1:128 prescaler
        movwf   OPTION_REG
        movlw   B'00101001'     ; RA0,3,5 = input, RA1,2,4 = output
        movwf	TRISA
        movlw   B'00000000'     ; RC0,1,2,3,4,5 = output, = input
        movwf	TRISC
		bcf STATUS,RP0 			; Bank 0

		call TXdelay			; Must wait at poweron before
		call trw_init			; init module
		call trw_address		; Set master address (to answer back)

main	call trw_setrx			; Enable rx
mw4msg	call trw_getpacket		; Get msg
		iorlw 0					; any ?
		btfsc STATUS,Z
		goto mw4msg				; no, loop
		bsf PORTC,2
		call TXdelay 			; give the master some time to enable Rx (Rabbit CAN-045 waits 3ms after Tx)
		; insert real processing here, remove prior call when not needed
		movlw 'A'				; yes, prepare ACK
		movwf message
		movlw 'C'
		movwf message+1
		movlw 'K'
		movwf message+2
		clrf message+3
		call trw_sendpacket		; and answer back
		call TXdelay 			; must wait >3ms so Tx goes out
		bcf PORTC,2
		goto main


TXdelay	clrf delay
		movlw guardconst
		movwf delay+1
l1		goto l1a
l1a		goto l1b
l1b		nop
		decfsz delay,f
		goto l1
		decfsz delay+1,f
		goto l1
		return

		end
